void adjclk(xdiff,cmos,ldst)
double xdiff;		/*difference to apply to local clock*/
int cmos;		/*cmos clock present if 1 */
int ldst;		/*daylight saving time observed if 1 */
{
#include <stdio.h>
#include <dos.h>
/*
	this subroutine adjusts the time of the local clock
	by algebraically adding xdiff seconds to it so that
	if xdiff is negative the local clock is retarded.

	if cmos = 1, then the cmos clock is adjusted as well.
*/
int mm;
int iday,ihr,imin,isec,ihun;	/*adjustment broken into bits*/
int hribm,minibm,secibm,hunibm;	/*bits of the local time */
int yribm,moibm,dayibm;		/*bits of the local date */
int centc,yrc,moc,dayc,hrc,minc,secc;  /*bits of cmos time*/
int lday[13]={0,31,28,31,30,31,30,31,31,30,31,30,31}; /*days in each mon*/
char cnvbcd(int);		/*converts integers to packed BCD*/
/*
	break correction down into days, hours, ...
	note that all corrections except for the days can only
	be +/- 1 or 0, but that the days correction can be
	arbitrarily large.
*/
	iday= (int) (xdiff/86400l);
	xdiff -= 86400l*(long int)iday;
	ihr= (int) (xdiff/3600);
	xdiff -= 3600l*(long int)ihr;
	imin= (int) (xdiff/60);
	xdiff -= 60*imin;
	isec= (int) xdiff;
	xdiff -= isec;
	ihun= 100*xdiff;
/*
	get local time and add correction. start with the
	least significant part of the time and deal with
	overflows into the next unit of the time if needed.
	note that even a small time correction can ripple
	through all of the units if it is made near the
	end of the day.

	note this this process may result in losing 1 tick
	on the local machine since a tick may happen in the
	time between the clock is read and the corrected
	value is put back.
*/
	_AH=0x2c;
	geninterrupt(0x21);
	hribm=_CH;
	minibm=_CL;
	secibm=_DH;
	hunibm=_DL;
	_AH=0x2a;
	geninterrupt(0x21);
	yribm=_CX;
	moibm=_DH;
	dayibm=_DL;
/*
	begin corrections
*/
	hunibm += ihun + 3;	/*round up one-half tick */
	if(hunibm > 99)
		{
		hunibm -= 100;
		secibm++;
	}
	if(hunibm < 0)
		{
		hunibm += 100;
		secibm--;
	}
	secibm += isec;
	if(secibm > 59)
		{
		secibm -= 60;
		minibm++;
	}
	if(secibm < 0)
		{
		secibm += 60;
		minibm--;
	}
	minibm += imin;
	if(minibm > 59)
		{
		minibm -= 60;
		hribm++;
	}
	if(minibm < 0)
		{
		minibm += 60;
		hribm--;
	}
	hribm += ihr;
	if(hribm > 23)
		{
		hribm -= 24;
		dayibm++;
	}
	if(hribm < 0)
		{
		hribm += 24;
		dayibm--;
	}
	dayibm += iday;
	while(dayibm < 1)	/*if pushed back to previous month*/
		{
		moibm--;	/*back up 1 month*/
		if(moibm < 1)	/*if month is pushed before Jan*/
			{
			moibm=12;		/*set december of previous year*/
			yribm--;
		}
		dayibm += lday[moibm];  /*add days of this month*/
/*
		feb. has 29 days if year-1900 is evenly divisible
		by 4
*/
		if( (        moibm == 2       )  &&
			 ( ( (yribm-1900) & 3) == 0) ) dayibm++;
	}
/*
	compute last day of this month, watching out for feb.
	in a leap year.  then see if the correction has pushed
	us into the next month.
*/
	mm=lday[moibm];
	if( (moibm == 2)  && ( ( (yribm-1900) & 3) == 0) ) mm++;
	while(dayibm > mm)
		{
		dayibm -= mm;
		moibm++;		/*advance to next month*/
		if(moibm > 12)	/*and to next year if needed*/
			{
			moibm=1;
			yribm++;
		}
		mm=lday[moibm];
		if( (moibm == 2) && ( ( (yribm-1900) & 3) ==0) ) mm++;
	}
/*
	now set local clock to this corrected time
*/
	_AH=0x2d;
	_CH=hribm;
	_DH=secibm;
	_CL=minibm;
	_DL=hunibm;
	geninterrupt(0x21);
	_AH=0x2b;
	_CX=yribm;
	_DH=moibm;
	_DL=dayibm;
	geninterrupt(0x21);
/*
	set cmos clock if needed. otherwise we are done.
*/
	if(cmos == 0) return;
/*
	convert time to packed bcd
*/
	centc=cnvbcd(yribm/100);
	yrc=cnvbcd(yribm%100);
	moc=cnvbcd(moibm);
	dayc=cnvbcd(dayibm);
	hrc=cnvbcd(hribm);
	minc=cnvbcd(minibm);
	if(hunibm > 50) secibm++;	/*round to nearest second*/
	secc=cnvbcd(secibm);
	_AH=3;
	_CH=hrc;
	_CL=minc;
	_DH=secc;
	_DL=ldst;
	geninterrupt(0x1a);
	_AH=5;
	_CH=centc;
	_CL=yrc;
	_DH=moc;
	_DL=dayc;
	geninterrupt(0x1a);
}