void inilin_l()
{
/*
        the IBM_PC version of this subroutine initializes the com 
	port defined by global cmport (0=com1, 1=com2, ... etc).
        the initialization parameters are set using param

        if BIOS is not defined, do not use bios calls but access the
        hardware directly.  this is done by determining the hardware
        address of the comport by looking in low core locations.

	the SUN version of this subroutine initializes the comport
	based on the device string dv which is defined in getdif.h
*/
#include <stdio.h>
#include "getdif.h"
#ifdef IBMPC
#include <dos.h>
char param;
void wait1s();		/*wait for DSR to come true */
void lockerr();		/*prints message to file and exits*/
#endif
int j;
#ifdef SUN
#include <sys/file.h>
#include <fcntl.h>
#include <sgtty.h>
struct sgttyb blah,*arg;     /* parameters used for ioctl calls */
	arg= &blah;           /* blah is structure */
	if( (cmport=open(dv,O_RDWR | O_NDELAY)) <0)
	   lockerr(" inilin -- cannot open serial port.");
	if(hs == 1)
	   {
	    arg->sg_ispeed=B1200;
	    arg->sg_ospeed=B1200;
	   }
	else
	   {
	   arg->sg_ispeed=B300;
	   arg->sg_ospeed=B300;
	   }
	arg->sg_erase='\177';
	arg->sg_kill='\025';
	arg->sg_flags=RAW;
	j=ioctl(cmport,TIOCSETP,arg);
	if(j != 0) lockerr("inilin --  ioctl status error");
#endif
#ifdef IBMPC
unsigned char stat;
#endif
/*
	operation of the IBMPC version:

        if this is the direct access version of the program, then the
        hardware address of the comport must be either specified in the
        configuration file or determined by looking in low memory.  if
        it was specified in the configuration file, then cmport was set
        to -1 there and cmadr was read from line 6.  in that case we
        don't have to do anything here.  if cmadr is positive, then
        the value must be determined here by looking at the table starting
        at address 400 (hex).
        following variables and code are used to look in low memory
        to get the address of the comport requested in the config. file
        if the address in low memory is zero, then exit with an error.
        since the line printer addresses are stored just after the tty
        port addresses, these variables are also used for getting the
        hardware address of lpt1 (see below)
*/
#ifdef IBMPC
unsigned int ttyseg = 0x40;
unsigned int ttyoff =    0;
int far *cmptr;
#ifndef BIOS
/*
        first get hardware address of requested comport if necessary
        these address are stored starting at 400.  if cmport is -1,
        then the address was already gotten by setcfg from the configuration
        file and we don't have to do that here.
*/
        if(cmport >= 0)
        {
        ttyoff=2*cmport;
        cmptr=MK_FP(ttyseg,ttyoff);
        cmadr=*cmptr;
        if(cmadr == 0)
	   lockerr("inilin -- comport not in configuration.");  
	}
/*
        disable interrupts, turn on DTR and RTS, then
        set 8 bits, no parity, 1 stop bit, Div. Latch Acc Bits on
*/
        param=0;
        outportb(cmadr+intena,param);
        param=3;
        outportb(cmadr+modreg,param);
        param='\x83';
        outportb(cmadr+lcreg,param);
/*
        now set requested speed using two halves of divisor
        from tables in interface manual
*/
        if(hs == 1)
           {
           param=96;
           outportb(cmadr+divlsb,param);
           param=0;
           outportb(cmadr+divmsb,param);
           }
        else
           {
           param='\x80';
           outportb(cmadr+divlsb,param);
           param=1;
           outportb(cmadr+divmsb,param);
           }
/*
        now turn off divisor latch access bits
*/
        param=3;
        outportb(cmadr+lcreg,param);
        wait1s();
        wait1s();
        wait1s();		/*wait for ROLM system to wake up*/
/*
        get modem status
*/
        stat=inportb(cmadr+msreg);
#endif
#ifdef BIOS
/*
        if we get here then we are going to do the same stuff using
        BIOS calls. the parameters are:

        300 baud        no parity       1 stop bit      8 bits
        0 1 0           0 0             0               1 1

        1200 baud       no parity       1 stop bit      8 bits
        1 0 0           0 0             0               1 1

        9600 baud       no parity       1 stop bit      8 bits
        1 1 1           0 0             0               1 1
*/
        if(hs == 1)param='\x83';
        else       param='\x43';
        _AL=param;
        _AH=0;
        _DX=cmport;
        geninterrupt(0x14);
        stat=_AL;           /* return with modem status  */
#endif
/*
        if this is automatic dialing using either manual or pulse mode
        then be sure that the modem is ready to go.  check DSR
*/
        if( (number[3] == 't') || (number[3] == 'T') ||
            (number[3] == 'p') || (number[3] == 'P') )
        {
        if( (stat & 0x20) == 0)
           lockerr("inilin --  modem does not show DSR");
        }
#endif
}
