#include "sizint.h"
ULONG s30(ULONG x)
{
/*
	performs a 30-bit circular left shift of x and returns
	result.  the input and output are assumed to be 32-bit
	quantities.  a right shift is assumed to propagate the
	sign bit which is masked off. this may not be needed
	for some compilers.
*/
ULONG temp;
	temp=x & 0xfffffffcu;	/*extract upper 30 bits*/
	temp= (temp >> 2) & 0x3fffffffu;  /*move to lower, mask off sign bits*/
	return( (x << 30) | temp);
}
