#include "sizint.h"
ULONG s5(ULONG x)
{
/*
	performs a 5-bit circular left shift of x and returns
	result.  the input and output are assumed to be 32-bit
	quantities.  a right shift is assumed to propagate the
	sign bit which is masked off. this may not be needed
	for some compilers.
*/
ULONG temp;
	temp=x & 0xf8000000u;	/*extract upper 5 bits*/
	temp= (temp >> 27) & 0x1f;	/*move to lower, mask off sign bits*/
	return( (x << 5) | temp);
}
